package models_test

import (
	"gitea.deepak.science/deepak/gogmagog/models"
	"gitea.deepak.science/deepak/gogmagog/store"
	"github.com/stretchr/testify/assert"
	"testing"
)

func TestModelCurrentPlan(t *testing.T) {
	assert := assert.New(t)
	a1 := &models.Action{ActionID: 3}
	userID := 3
	p := &models.Plan{PlanID: 6}

	str, _ := store.GetInMemoryStore()
	str.InsertAction(a1, userID)
	str.InsertPlan(p, userID)
	str.InsertPlan(p, userID)
	m := models.New(str)

	_, err := m.CurrentPlan(userID)
	assert.NotNil(err)
	assert.True(models.IsNotFoundError(err))

	err = m.AddCurrentPlan(&models.CurrentPlan{PlanID: 1}, userID)
	assert.Nil(err)

	pp, err := m.CurrentPlan(userID)
	assert.Nil(err)
	assert.EqualValues(1, pp.PlanID)
	assert.EqualValues(userID, pp.UserID)

	err = m.AddCurrentPlan(&models.CurrentPlan{PlanID: 2}, userID)
	assert.NotNil(err)

	err = m.SaveCurrentPlan(&models.CurrentPlan{PlanID: 2}, userID)
	assert.Nil(err)

	pp, err = m.CurrentPlan(userID)
	assert.Nil(err)
	assert.EqualValues(2, pp.PlanID)
	assert.EqualValues(userID, pp.UserID)

}
